package Gelateria;

import java.util.HashMap;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class Gelateria {
	
	final static int dimPalla = 45;
	HashMap<Integer,Vaschetta> vaschette = new HashMap<Integer,Vaschetta>(); 
	Lock l = new ReentrantLock();
	Condition c = l.newCondition();
	
	public void getCono(int Gusto1, int Gusto2) throws InterruptedException
	{
		l.lock();
		Vaschetta v1;
		Vaschetta v2;
		v1 = vaschette.get(Gusto1);
		v2 = vaschette.get(Gusto2);
		while ( ! (v1.quantita >= dimPalla && v2.quantita >= dimPalla)  )
		{
			c.await();
		}
		v1.quantita -= dimPalla;
		v2.quantita -= dimPalla;
		
		l.unlock();
	}
	
	Vaschetta cercaGustoAlternativo(int Gusto)
	{
		Vaschetta v = null;
	    for (Integer k : vaschette.keySet() ) 
	    {
	    	if (k != Gusto && (v = vaschette.get(k)).quantita >= dimPalla )
	    	{
	    		//v.quantita -= dimPalla;
	    		return v;
	    	}
	    		
	    }
		return v;
	}
	
	int prendiGusto(int Gusto)
	{
		Vaschetta v = vaschette.get(Gusto);
		Vaschetta old;
		old = v;
		boolean cambio = false;
		
		if (v.quantita < dimPalla)
		{
			v = cercaGustoAlternativo(Gusto);
			if (v != old)
				cambio = true;
		}
		if (v != null)
		{
			v.quantita -= dimPalla;
		}
		else 
			return -1;
		if (cambio)
			return 0;
		else return 1;
			
		
	}
	
	public int getConoCumeDede(int Gusto1, int Gusto2)
	{
		l.lock();
		try {
		int r1 = prendiGusto(Gusto1);
		int r2 = prendiGusto(Gusto2);
		
		if( r1 == 1 &&  r2 == 1 )
			return 1;
		else if (r1 == -1 || r2 == -1)
			return -1;
		else return 0;
		}
		finally {
			l.unlock();
		}

	}
	public void riempi(Vaschetta v)
	{
		l.lock();
		v.quantita = 1000;
		c.signalAll();
		l.unlock();
	}
}
